Attribute VB_Name = "waveout"
Declare Function waveOutBreakLoop Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutGetDevCaps Lib "winmm.dll" Alias "waveOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As WAVEOUTCAPS, ByVal uSize As Long) As Long
Declare Function waveOutGetErrorText Lib "winmm.dll" Alias "waveOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Declare Function waveOutGetID Lib "winmm.dll" (ByVal hWaveout As Long, lpuDeviceID As Long) As Long
Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Declare Function waveOutGetPitch Lib "winmm.dll" (ByVal hWaveout As Long, lpdwPitch As Long) As Long
Declare Function waveOutGetPlaybackRate Lib "winmm.dll" (ByVal hWaveout As Long, lpdwRate As Long) As Long
Declare Function waveOutGetPosition Lib "winmm.dll" (ByVal hWaveout As Long, lpInfo As MMTIME, ByVal uSize As Long) As Long
Declare Function waveOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function waveOutMessage Lib "winmm.dll" (ByVal hWaveout As Long, ByVal msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
Declare Function waveOutOpen Lib "winmm.dll" (lphWaveOut As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMAT, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Declare Function waveOutPause Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutPrepareHeader Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutRestart Lib "winmm.dll" (ByVal hWaveout As Long) As Long
Declare Function waveOutSetPitch Lib "winmm.dll" (ByVal hWaveout As Long, ByVal dwPitch As Long) As Long
Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Declare Function waveOutSetPlaybackRate Lib "winmm.dll" (ByVal hWaveout As Long, ByVal dwRate As Long) As Long
Declare Function waveOutUnprepareHeader Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutWrite Lib "winmm.dll" (ByVal hWaveout As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Type WAVEFORMAT
        wFormatTag As Integer
        nChannels As Integer
        nSamplesPerSec As Long
        nAvgBytesPerSec As Long
        nBlockAlign As Integer
        PerBit As Integer
End Type
Type WAVEHDR
        lpData As Long
        dwBufferLength As Long
        dwBytesRecorded As Long
        dwUser As Long
        dwFlags As Long
        dwLoops As Long
        lpNext As Long
        Reserved As Long
End Type
Type WAVEOUTCAPS
        wMid As Integer
        wPid As Integer
        vDriverVersion As Long
        szPname As String * 32
        dwFormats As Long
        wChannels As Integer
        dwSupport As Long
End Type

Type MMTIME
        wType As Integer
        u As Long
        v As Long
End Type

Const PI = 3.1415926535
Dim hWaveout As Long
Dim WF As WAVEFORMAT
Dim WH As WAVEHDR
Dim WOC As WAVEOUTCAPS

Sub InitWaveOut()


With WF
  .wFormatTag = 1
  .nChannels = 1 'm
  .nSamplesPerSec = 11025 'g
  .nAvgBytesPerSec = 11025
  .nBlockAlign = 1
  .PerBit = 8
End With

Call waveOutOpen(hWaveout, -1, WF, 0, 0, 0)



End Sub

Sub PlayWaveOut(buf() As Byte)

If hWaveout = 0 Then Exit Sub

With WH
  .lpData = VarPtr(buf(0))
  .dwBufferLength = UBound(buf) + 1
  .dwFlags = 12
  .dwLoops = 1
End With

Call waveOutPrepareHeader(hWaveout, WH, LenB(WH))
Call waveOutWrite(hWaveout, WH, LenB(WH))
'MsgBox waveOutRestart(hWaveout)

End Sub

Sub QuitWaveOut()

If hWaveout = 0 Then Exit Sub
Call waveOutReset(hWaveout)
Call waveOutUnprepareHeader(hWaveout, WH, LenB(WH))
Call waveOutClose(hWaveout)

End Sub

Sub StopWaveOut()

If hWaveout = 0 Then Exit Sub
Call waveOutReset(hWaveout)

End Sub

Sub a(ByVal l1 As Long, ByVal l2 As Long, ByVal l3 As Long, ByVal l4 As Long, ByVal l5 As Long)
'Form1.Caption = Time
End Sub

Function GetPositionByte() As Long
Dim MM As MMTIME, i&
Call waveOutGetPosition(hWaveout, MM, LenB(MM))
GetPositionByte = MM.u

End Function

