Attribute VB_Name = "gpusound"
Option Explicit

'鉹F
Public Const SOUND_SIZE = 256&
Public Const SOUND_FREQ = 11025&

Public Const WAVE_WIDTH = 256&
Public Const WAVE_TYPE = 8&
Public Const TEX_SOUND = 1&
Public Const TEX_WAVE = 2&
Public wavebuf() As Byte
Public DrawSkip As Boolean


Sub CreateWaveTexture()
Dim ms As MemState
Dim buf() As Byte
Dim v As Long, x As Long, y As Long, t As Long, b As Byte

'g`eNX`
ReDim buf(WAVE_TYPE * WAVE_WIDTH * 4 - 1) As Byte

For x = 0 To WAVE_WIDTH - 1
  For y = 0 To WAVE_TYPE - 1
    Select Case y
    Case 0
      'Opg
      If x < WAVE_WIDTH / 4 Then
        v = 127 + 512 * x / WAVE_WIDTH
      ElseIf x < WAVE_WIDTH * (3 / 4) Then
        v = 383 - 512 * x / WAVE_WIDTH
      Else
        v = 512 * x / WAVE_WIDTH - 383
      End If
    Case 1
      'sing
      v = 128 + 127 * Sin(x / WAVE_WIDTH * 2 * 3.1415926784)
    Case 2
      'mRMh
      v = 256 * x / WAVE_WIDTH
    Case 3
      '1:1`g
      v = IIf(x < WAVE_WIDTH / 2, 255, 0)
    Case 4
      '1:3`g
      v = IIf(x < WAVE_WIDTH / 4, 255, 0)
    Case 5
      '1:7`g
      v = IIf(x < WAVE_WIDTH / 8, 255, 0)
    Case 6
      'mCY
      v = Rnd * 256
    Case Else
      v = 127
    End Select
    
    If v < 0 Then v = 0
    If v > 255 Then v = 255
    
    t = (y * WAVE_WIDTH + x) * 4
    buf(t) = v
    buf(t + 1) = v
    buf(t + 2) = v
    buf(t + 3) = 255 'alpha
  Next
Next

Call DTLock(TEX_WAVE, ms)

For y = 0 To WAVE_TYPE - 1
  Call CopyValtoPtr(ms.lpSurface + y * ms.lPitch, buf(y * WAVE_WIDTH * 4), WAVE_WIDTH * 4)
Next


Call DTUnlock(TEX_WAVE, ms)

End Sub

Private Sub PutNote_sub(ByRef v() As D3DTLVERTEX, ByVal SrcOp As Long, ByVal DestOp As Long, ByVal Col As Long)
'PutNoteŋʕ֐

With objD3DDevice
  Call .SetRenderState(D3DRENDERSTATE_SRCBLEND, SrcOp)
  Call .SetRenderState(D3DRENDERSTATE_DESTBLEND, DestOp)
  v(0).color = Col: v(1).color = Col
  v(2).color = Col: v(3).color = Col
  Call .DrawPrimitive(D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, v(0), 4, D3DDP_DEFAULT)
End With

End Sub


Sub PutNote(ByVal Freq As Single, ByVal stim As Single, ByVal length As Single, ByVal vol As Long, ByVal inst As Long)
Dim pos&, epos&, npos&, loopsize&, loopcnt&, row&
Dim phase!, dphase!, i&, Col&
Static v(3) As D3DTLVERTEX
Static nofirst As Boolean

'xgϐ͏͂PɂĂ
If nofirst = False Then
  For i = 0 To 3
    v(i).specular = &HFFFFFFFF
    v(i).rhw = 1
  Next
  nofirst = True
End If

'JnʒuƏIʒuԂsNZʒuɏ
pos = stim * SOUND_FREQ
epos = (stim + length) * SOUND_FREQ
loopsize = SOUND_SIZE * SOUND_SIZE

'ʑ0X^[g
phase = 0

'sNZ̈ʑωʂɏĂ
dphase = Freq / SOUND_FREQ

If vol < 0 Then Exit Sub
If vol > 127 Then vol = 127

Call objD3DDevice.BeginScene


'1s
Do While pos < epos And pos < loopsize * 3
  '̍s܂ł̈ʒu
  npos = ((pos + SOUND_SIZE) \ SOUND_SIZE) * SOUND_SIZE
  If npos > epos Then npos = epos
  
  '݂̍s
  row = (pos \ SOUND_SIZE) Mod SOUND_SIZE
  
  '݂̎(R,G,B,A)
  loopcnt = pos \ (SOUND_SIZE * SOUND_SIZE)
  
  
  '`lp`
  v(0).sx = pos Mod SOUND_SIZE
  v(0).sy = row
  v(1).sx = IIf(npos Mod SOUND_SIZE = 0, SOUND_SIZE, npos Mod SOUND_SIZE)
  v(1).sy = v(0).sy
  v(2).sx = v(0).sx
  v(2).sy = v(0).sy + 1
  v(3).sx = v(1).sx
  v(3).sy = v(2).sy
  
  '`挳g`
  v(0).tu = phase
  v(0).tv = (inst + 0.5) / WAVE_TYPE
  v(1).tu = phase + (npos - pos) * dphase
  v(1).tv = v(0).tv
  v(2).tu = v(0).tu
  v(2).tv = (inst + 1.5) / WAVE_TYPE
  v(3).tu = v(1).tu
  v(3).tv = v(2).tv
    
  'Zl-V`+VƂꍇAۂɂ͌Z邱ƂoȂ
  'ŁA܂VĂ0`2V𑫂
  'Z͏oȂ̂ŁAV̌Zȉ̂悤ɕ`悷
  '`𔽓]V𑫂ēx]
  '
  
  'ŏǍZ܂ł̓eNX`͊֌WȂ
  'Ȃ̂ŕs܂Ƃ߂čsƂo邪AvO̊ȗ̂ߍsƂɍsĂ
  'SetTextureStageStateSetRenderState̎Ԃ͂܂ǂˁEEE
  With objD3DDevice
    
    '---------------------------------------------------------------------
    'eNX`̒l͖A͂Fl̂
    Call .SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG2)
    Call .SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2)

    ']
    'Result = Src * (1 - Dest) + Dest * 0
    'Src = 1iő̐FlBł&HFFFFFFFFjƂĂƂŁAResult = 1 - Dest
    Call PutNote_sub(v, D3DBLEND_INVDESTCOLOR, D3DBLEND_ZERO, &HFFFFFFFF)
    
    'Z
    'Result = Src + Dest
    'DestŌV̒l
    Col = vol * Choose(loopcnt + 1, &H10000, &H100, 1) Or &HFF000000
    Call PutNote_sub(v, D3DBLEND_ONE, D3DBLEND_ONE, Col)

    '܂]Ōɖ߂
    Call PutNote_sub(v, D3DBLEND_INVDESTCOLOR, D3DBLEND_ZERO, &HFFFFFFFF)
  
    '---------------------------------------------------------------------
    'ꂩ烁C̕`
    
    'eNX`̒lƃ{[l͏Zɖ߂Ă
    Call .SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call .SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE)
      
    'FlvZ
    Col = vol * 2 * Choose(loopcnt + 1, &H10000, &H100, 1) Or &HFF000000
    
    'Z`
    Call PutNote_sub(v, D3DBLEND_ONE, D3DBLEND_ONE, Col)
  
  End With
  
  phase = phase + (npos - pos) * dphase
  pos = npos


Loop

Call objD3DDevice.EndScene

With objD3DDevice
  Call .SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA)
  Call .SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA)
  Call .SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
  Call .SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE)
End With

End Sub


Function StrToFreq(s As String) As Single
Dim t$, f!, i&

If s = "" Then Exit Function

t = Left(LCase(s), 1)

Select Case t
Case "c": f = 0
Case "d": f = 2 / 12
Case "e": f = 4 / 12
Case "f": f = 5 / 12
Case "g": f = 7 / 12
Case "a": f = 9 / 12
Case "b": f = 11 / 12
Case Else: Exit Function
End Select

f = 440 * (2 ^ f)

For i = 2 To Len(s)
  Select Case Mid(s, i, 1)
  Case "+": f = f * 2
  Case "-": f = f / 2
  Case "#": f = f * (2 ^ (1 / 12))
  Case "$": f = f / (2 ^ (1 / 12))
  End Select
Next

StrToFreq = f

End Function

Sub ReadSoundBuffer()
Dim ms As MemState, x&, y&, t1&, t2&, t3&, v&, finpos&
Dim buf() As Byte

'eNX`̓eobt@ɓǂݍ
ReDim wavebuf(SOUND_SIZE * SOUND_SIZE * 3 - 1) As Byte
ReDim buf(SOUND_SIZE * SOUND_SIZE * 4 - 1) As Byte

Call DTLock(TEX_SOUND, ms)

For y = 0 To SOUND_SIZE - 1
  Call CopyPtrtoVal(buf(y * SOUND_SIZE * 4), ms.lpSurface + y * ms.lPitch, SOUND_SIZE * 4)
Next

Call DTUnlock(TEX_SOUND, ms)

'RGBȀԂבւobt@ɋl߂Ă
For y = 0 To SOUND_SIZE - 1
  t2 = y * SOUND_SIZE * 4
  For x = 0 To SOUND_SIZE - 1
    t1 = SOUND_SIZE * SOUND_SIZE
    t3 = y * SOUND_SIZE + x
    wavebuf(t3 + t1 * 2) = buf(t2 + x * 4) 'B
    wavebuf(t3 + t1 * 1) = buf(t2 + x * 4 + 1) 'G
    wavebuf(t3 + t1 * 0) = buf(t2 + x * 4 + 2) 'R
  Next
Next

For finpos = SOUND_SIZE * SOUND_SIZE * 3 - 1 To 0 Step -1
  If wavebuf(finpos) <> &H7F Then Exit For
Next

If finpos < 0 Then finpos = 0
ReDim Preserve wavebuf(finpos) As Byte

End Sub

Sub CreateSound()
Dim ms As MemState, x&, y&, t1&, t2&, t3&, v&, finpos&
Dim buf() As Byte
Dim vp As D3DVIEWPORT7

DrawSkip = True
'^񒆂̒lŃNA
Call DTClear(TEX_SOUND, &H7F7F7F7F, 0)

With objD3DDevice
  Call .SetTexture(0, objBS(TEX_WAVE))
  Call .SetRenderTarget(objBS(TEX_SOUND))
      
  '`Ԃŕ`
  Call .SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFN_LINEAR)
  Call .SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_LINEAR)
    
  Call .SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, True)
End With



'h~t@\VhhV\t@~h
x = 50
y = Form1.Combo1.ListIndex
Call PutNote(StrToFreq("c"), 0, 0.5, x, y)
Call PutNote(StrToFreq("d"), 0.5, 0.5, x, y)
Call PutNote(StrToFreq("e"), 1, 0.5, x, y)
Call PutNote(StrToFreq("f"), 1.5, 0.5, x, y)
Call PutNote(StrToFreq("g"), 2, 0.5, x, y)
Call PutNote(StrToFreq("a"), 2.5, 0.5, x, y)
Call PutNote(StrToFreq("b"), 3, 0.5, x, y)
Call PutNote(StrToFreq("c+"), 3.5, 0.5, x, y)

Call PutNote(StrToFreq("c"), 7.5, 0.5, x, y)
Call PutNote(StrToFreq("d"), 7, 0.5, x, y)
Call PutNote(StrToFreq("e"), 6.5, 0.5, x, y)
Call PutNote(StrToFreq("f"), 6, 0.5, x, y)
Call PutNote(StrToFreq("g"), 5.5, 0.5, x, y)
Call PutNote(StrToFreq("a"), 5, 0.5, x, y)
Call PutNote(StrToFreq("b"), 4.5, 0.5, x, y)
Call PutNote(StrToFreq("c+"), 4, 0.5, x, y)



Call ReadSoundBuffer

With objD3DDevice
  Call .SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFN_POINT)
  Call .SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFN_POINT)
  Call .SetRenderTarget(objBS(0))
End With

'GeForce8600HALƁAviewportĐݒ肵Ȃƃ_B
'HELƖȂ񂾂ǂȂB
With vp
  .lX = 0
  .lY = 0
  .lWidth = 640
  .lHeight = 480
  .minz = 0
  .maxz = 0
End With
Call objD3DDevice.SetViewport(vp)

DrawSkip = False

Exit Sub


End Sub
